package org.bench4q.master.domain.valueobject.datastatistics.impl;

import java.util.HashMap;
import java.util.Map;

import org.bench4q.share.models.agent.BehaviorBriefModel;
import org.bench4q.share.models.agent.BehaviorStatusCodeResultModel;
import org.bench4q.share.models.agent.statistics.DataStatisticsModel;
import org.bench4q.share.models.master.statistics.ScriptBehaviorBriefModel;

public class BehaviorBriefStatistics extends ScriptStatistics {
	private long countFromBegin;
	private long countThisTime;
	private long successCountThisTime;
	private long successCountFromBegin;
	private long maxResponseTimeFromBegin;
	private long minResponseTimeFromBegin;
	private long totalResponseTimeThisTime;

	private volatile Map<Integer, BehaviorStatusCodeResultModel> behaviorStatusMap;

	public BehaviorBriefStatistics() {
		this.behaviorStatusMap = new HashMap<Integer, BehaviorStatusCodeResultModel>();
		resetTempraryFields();
		this.maxResponseTimeFromBegin = 0;
		this.minResponseTimeFromBegin = Long.MAX_VALUE;
	}

	/**
	 * Now, for totalCount, i just collect all result from agent, and add their
	 * countFromBegin together. But there will be a error there. if an agent
	 * doesn't give back its result, the the countFromBegin maybe less that last
	 * one.
	 */
	private void resetTempraryFields() {
		this.countFromBegin = 0;
		this.countThisTime = 0;
		this.successCountThisTime = 0;
		this.successCountFromBegin = 0;
		this.totalResponseTimeThisTime = 0;
	}

	@Override
	public void add(DataStatisticsModel dataUnit) {
		if (!(dataUnit instanceof BehaviorBriefModel)) {
			return;
		}
		BehaviorBriefModel behaviorBriefModel = (BehaviorBriefModel) dataUnit;
		this.countFromBegin += behaviorBriefModel.getTotalCount();
		this.successCountFromBegin += behaviorBriefModel.getSuccessfulCount();
		for (BehaviorStatusCodeResultModel newOne : behaviorBriefModel
				.getDetailStatusCodeResultModels()) {
			if (!this.behaviorStatusMap.containsKey(newOne.getStatusCode())) {
				behaviorStatusMap.put(newOne.getStatusCode(), newOne);
				continue;
			}
			BehaviorStatusCodeResultModel origin = behaviorStatusMap.get(newOne
					.getStatusCode());
			origin.plus(newOne);
		}
	}

	@Override
	public Object getStatistics() {
		ScriptBehaviorBriefModel result = new ScriptBehaviorBriefModel();

		return null;
	}

}
